Index: squid/lib/win32lib.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/lib/win32lib.c,v
retrieving revision 1.1.2.4
retrieving revision 1.1.2.4.2.1
diff -u -r1.1.2.4 -r1.1.2.4.2.1
--- squid/lib/win32lib.c	28 Jul 2001 10:18:13 -0000	1.1.2.4
+++ squid/lib/win32lib.c	27 Aug 2001 21:48:18 -0000	1.1.2.4.2.1
@@ -1,5 +1,5 @@
 /*
- * $Id: win32lib.c,v 1.1.2.4 2001/07/28 10:18:13 serassio Exp $
+ * $Id: win32lib.c,v 1.1.2.4.2.1 2001/08/27 21:48:18 tolsty Exp $
  *
  * * * * * * * * Legal stuff * * * * * * *
  *
@@ -26,6 +26,9 @@
 /* The following code section is part of an EXPERIMENTAL native */
 /* Windows NT/2000 Squid port - Compiles only on MS Visual C++  */
 #if defined(_SQUID_MSWIN_)
+#undef assert
+#include <assert.h>
+
 #include <stdio.h>
 #include <windows.h>
 #include <process.h>
@@ -36,72 +39,201 @@
 #define OPTERRNF (2)
 #define OPTERRARG (3)
 
+__declspec(thread) int ws32_result;
+
 char *optarg;
 int optreset = 0;
 int optind = 1;
 int opterr = 1;
 int optopt;
 
-int chroot (const char *dirname)
+int
+chroot(const char *dirname)
 {
-	if (SetCurrentDirectory(dirname))
-		return 0;
-	else
-		return GetLastError();
+    if (SetCurrentDirectory(dirname))
+	return 0;
+    else
+	return GetLastError();
+}
+
+static void
+EnableDebugPrivileges(void)
+{
+    HANDLE hToken;
+    LUID sedebugnameValue;
+    TOKEN_PRIVILEGES tkp;
+
+    if (!OpenProcessToken(GetCurrentProcess(),
+	    TOKEN_ADJUST_PRIVILEGES | TOKEN_QUERY, &hToken))
+	return;
+
+    if (!LookupPrivilegeValue(NULL, SE_DEBUG_NAME, &sedebugnameValue)) {
+	CloseHandle(hToken);
+	return;
+    }
+
+    tkp.PrivilegeCount = 1;
+    tkp.Privileges[0].Luid = sedebugnameValue;
+    tkp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
+
+    AdjustTokenPrivileges(hToken, FALSE, &tkp, sizeof tkp, NULL, NULL);
+
+    CloseHandle(hToken);
+}
+
+typedef struct kill_params
+{
+    BOOL retval;
+    int sig;
+        FARPROC(WINAPI * GetProcAddress) (HMODULE hModule, LPCSTR lpProcName);
+        HMODULE(WINAPI * GetModuleHandle) (LPCTSTR lpModuleName);
+    char procname[64];
 }
+kill_params;
 
-int kill(pid_t pid, int sig)
+static DWORD WINAPI
+signalSquid(kill_params * params)
 {
-   	HANDLE hProcess;
+    int (WINAPI * _WIN32_sendSignal) (int WIN32_signal);
+    HANDLE hModule;
+
+    params->retval = FALSE;
+    hModule = params->GetModuleHandle(NULL);
+    if (hModule) {
+	(FARPROC) _WIN32_sendSignal = params->GetProcAddress(hModule, params->procname);
+	if (_WIN32_sendSignal)
+	    params->retval = _WIN32_sendSignal(params->sig);
+    }
+    return 0;
+}
 
-	if (sig == 0) {
-		if ((hProcess = OpenProcess(PROCESS_QUERY_INFORMATION |
-		    PROCESS_VM_READ,
-		    FALSE, pid)) == NULL)
-				return -1;
-		else {
-        	CloseHandle(hProcess);
-			return 0;
-		}
+int
+kill(pid_t pid, int sig)
+{
+    HANDLE hProcess;
+    HANDLE hThread = NULL;
+    HMODULE hLib = NULL;
+    int retval = -1;
+    kill_params *rparams = NULL, lparams;
+    LPVOID code = NULL, params = NULL;
+    DWORD rc;
+
+    EnableDebugPrivileges();
+
+    if (NULL == (hProcess =
+	    OpenProcess(PROCESS_CREATE_THREAD | PROCESS_QUERY_INFORMATION |
+		PROCESS_VM_OPERATION | PROCESS_VM_WRITE | PROCESS_VM_READ,
+		FALSE, pid))) {
+	goto cleanup;
+    }
+
+    if (sig == 0) {
+	retval = 0;
+	goto cleanup;
+    }
+
+    if (!(rparams =
+	    VirtualAllocEx(hProcess, 0, 512, MEM_COMMIT,
+	PAGE_EXECUTE_READWRITE))) goto cleanup;
+
+    code = (char *) rparams + sizeof(kill_params);
+
+    if (!WriteProcessMemory(hProcess, code, &signalSquid,
+	    512 - sizeof(kill_params), 0))
+	goto cleanup;
+
+    lparams.retval = FALSE;
+    lparams.sig = sig;
+    strcpy(lparams.procname, "WIN32_sendSignal");
+
+    if (!(hLib = LoadLibrary("kernel32.dll")))
+	goto cleanup;
+    if (!((FARPROC) lparams.GetModuleHandle =
+	    GetProcAddress(hLib, "GetModuleHandleA")))
+	goto cleanup;
+    if (!((FARPROC) lparams.GetProcAddress =
+	    GetProcAddress(hLib, "GetProcAddress")))
+	goto cleanup;
+
+    if (!WriteProcessMemory(hProcess, rparams, &lparams, sizeof(lparams), 0))
+	goto cleanup;
+
+    if (!(hThread =
+	    CreateRemoteThread(hProcess, NULL, 0, (LPTHREAD_START_ROUTINE) code,
+		rparams, 0, &rc)))
+	goto cleanup;
+
+    rc = WaitForSingleObject(hThread, 3000);
+    switch (rc) {
+    case WAIT_OBJECT_0:
+	if (!ReadProcessMemory(hProcess, rparams, &lparams, sizeof(lparams),
+		&rc)) {
+	    goto cleanup;
 	}
-	else return 0;
+	if (lparams.retval) {
+	    retval = 0;
+	    printf("Signal %d sent to process %ld\n", sig, pid);
+	}
+	break;
+    case WAIT_TIMEOUT:
+    case WAIT_FAILED:
+    default:
+	break;
+    }
+
+  cleanup:
+    rc = GetLastError();
+    if (retval && sig)
+	fprintf(stderr, "GetLastError(): %ld ", rc);
+    _dosmaperr(rc);
+
+    if (hLib)
+	FreeLibrary(hLib);
+    if (hThread)
+	CloseHandle(hThread);
+    if (rparams)
+	VirtualFreeEx(hProcess, rparams, 0, MEM_RELEASE);
+    CloseHandle(hProcess);
+
+    return retval;
 }
 
-void gettimeofday( struct timeval * pcur_time,void * tz){
-	struct _timeb current;
-	_ftime(&current);
-	pcur_time->tv_sec=current.time;
-	pcur_time->tv_usec=current.millitm * 1000;
+int
+gettimeofday(struct timeval *pcur_time, void *tz)
+{
+    struct _timeb current;
+    _ftime(&current);
+    pcur_time->tv_sec = current.time;
+    pcur_time->tv_usec = current.millitm * 1000;
+    return 0;
 }
 
-int statfs(const char *path, struct statfs *sfs)
+int
+statfs(const char *path, struct statfs *sfs)
 {
     char drive[4];
     DWORD spc, bps, freec, totalc;
     DWORD vsn, maxlen, flags;
 
-    if (!sfs)
-    {
-		errno=EINVAL;
-		return -1;
-    }
-
-    strncpy(drive,path,2);
-	drive[2]='\0';
-	strcat(drive,"\\");
-
-	if (!GetDiskFreeSpace(drive, &spc, &bps, &freec, &totalc))
-    {
-      errno=ENOENT;
-      return -1;
-    }
-    if (!GetVolumeInformation(drive, NULL, 0, &vsn, &maxlen, &flags, NULL, 0))
-    {
-      errno=ENOENT;
-      return -1;
+    if (!sfs) {
+	errno = EINVAL;
+	return -1;
+    }
+
+    strncpy(drive, path, 2);
+    drive[2] = '\0';
+    strcat(drive, "\\");
+
+    if (!GetDiskFreeSpace(drive, &spc, &bps, &freec, &totalc)) {
+	errno = ENOENT;
+	return -1;
+    }
+    if (!GetVolumeInformation(drive, NULL, 0, &vsn, &maxlen, &flags, NULL, 0)) {
+	errno = ENOENT;
+	return -1;
     }
     sfs->f_type = flags;
-    sfs->f_bsize = spc*bps;
+    sfs->f_bsize = spc * bps;
     sfs->f_blocks = totalc;
     sfs->f_bfree = sfs->f_bavail = freec;
     sfs->f_files = -1;
@@ -111,214 +243,190 @@
     return 0;
 }
 
-int mkdir(const char * path, mode_t mode)
-
-{
-    if (CreateDirectory(path, NULL) != 0)
-	return 0;
-    else
-	return -1;
-}
-
-
-
 static int
-optiserr(int argc, char * const *argv, int oint, const char *optstr,
-         int optchr, int err)
+optiserr(int argc, char *const *argv, int oint, const char *optstr,
+    int optchr, int err)
 {
-    if(opterr)
-    {
-        fprintf(stderr, "Error in argument %d, char %d: ", oint, optchr+1);
-        switch(err)
-        {
-        case OPTERRCOLON:
-            fprintf(stderr, ": in flags\n");
-            break;
-        case OPTERRNF:
-            fprintf(stderr, "option not found %c\n", argv[oint][optchr]);
-            break;
-        case OPTERRARG:
-            fprintf(stderr, "no argument for option %c\n", argv[oint][optchr]);
-            break;
-        default:
-            fprintf(stderr, "unknown\n");
-            break;
-        }
+    if (opterr) {
+	fprintf(stderr, "Error in argument %d, char %d: ", oint, optchr + 1);
+	switch (err) {
+	case OPTERRCOLON:
+	    fprintf(stderr, ": in flags\n");
+	    break;
+	case OPTERRNF:
+	    fprintf(stderr, "option not found %c\n", argv[oint][optchr]);
+	    break;
+	case OPTERRARG:
+	    fprintf(stderr, "no argument for option %c\n", argv[oint][optchr]);
+	    break;
+	default:
+	    fprintf(stderr, "unknown\n");
+	    break;
+	}
     }
     optopt = argv[oint][optchr];
-    return('?');
+    return ('?');
 }
-    
 
 int
-getopt(int argc, char* const *argv, const char *optstr)
+getopt(int argc, char *const *argv, const char *optstr)
 {
     static int optchr = 0;
-    static int dash = 0; /* have already seen the - */
+    static int dash = 0;	/* have already seen the - */
 
     char *cp;
 
     if (optreset)
-        optreset = optchr = dash = 0;
-    if(optind >= argc)
-        return(EOF);
-    if(!dash && (argv[optind][0] !=  '-'))
-        return(EOF);
-    if(!dash && (argv[optind][0] ==  '-') && !argv[optind][1])
-    {
-        /*
-         * use to specify stdin. Need to let pgm process this and
-         * the following args
-         */
-        return(EOF);
-    }
-    if((argv[optind][0] == '-') && (argv[optind][1] == '-'))
-    {
-        /* -- indicates end of args */
-        optind++;
-        return(EOF);
-    }
-    if(!dash)
-    {
-        assert((argv[optind][0] == '-') && argv[optind][1]);
-        dash = 1;
-        optchr = 1;
+	optreset = optchr = dash = 0;
+    if (optind >= argc)
+	return (EOF);
+    if (!dash && (argv[optind][0] != '-'))
+	return (EOF);
+    if (!dash && (argv[optind][0] == '-') && !argv[optind][1]) {
+	/*
+	 * use to specify stdin. Need to let pgm process this and
+	 * the following args
+	 */
+	return (EOF);
+    }
+    if ((argv[optind][0] == '-') && (argv[optind][1] == '-')) {
+	/* -- indicates end of args */
+	optind++;
+	return (EOF);
+    }
+    if (!dash) {
+	assert((argv[optind][0] == '-') && argv[optind][1]);
+	dash = 1;
+	optchr = 1;
     }
 
     /* Check if the guy tries to do a -: kind of flag */
     assert(dash);
-    if(argv[optind][optchr] == ':')
-    {
-        dash = 0;
-        optind++;
-        return(optiserr(argc, argv, optind-1, optstr, optchr, OPTERRCOLON));
-    }
-    if(!(cp = strchr(optstr, argv[optind][optchr])))
-    {
-        int errind = optind;
-        int errchr = optchr;
-
-        if(!argv[optind][optchr+1])
-        {
-            dash = 0;
-            optind++;
-        }
-        else
-            optchr++;
-        return(optiserr(argc, argv, errind, optstr, errchr, OPTERRNF));
-    }
-    if(cp[1] == ':')
-    {
-        dash = 0;
-        optind++;
-        if(optind == argc)
-            return(optiserr(argc, argv, optind-1, optstr, optchr, OPTERRARG));
-        optarg = argv[optind++];
-        return(*cp);
-    }
-    else
-    {
-        if(!argv[optind][optchr+1])
-        {
-            dash = 0;
-            optind++;
-        }
-        else
-            optchr++;
-        return(*cp);
+    if (argv[optind][optchr] == ':') {
+	dash = 0;
+	optind++;
+	return (optiserr(argc, argv, optind - 1, optstr, optchr, OPTERRCOLON));
+    }
+    if (!(cp = strchr(optstr, argv[optind][optchr]))) {
+	int errind = optind;
+	int errchr = optchr;
+
+	if (!argv[optind][optchr + 1]) {
+	    dash = 0;
+	    optind++;
+	} else
+	    optchr++;
+	return (optiserr(argc, argv, errind, optstr, errchr, OPTERRNF));
+    }
+    if (cp[1] == ':') {
+	dash = 0;
+	optind++;
+	if (optind == argc)
+	    return (optiserr(argc, argv, optind - 1, optstr, optchr,
+		    OPTERRARG));
+	optarg = argv[optind++];
+	return (*cp);
+    } else {
+	if (!argv[optind][optchr + 1]) {
+	    dash = 0;
+	    optind++;
+	} else
+	    optchr++;
+	return (*cp);
     }
     assert(0);
-    return(0);
+    return (0);
 }
 
 #ifdef TESTGETOPT
 int
- main (int argc, char **argv)
- {
-      int c;
-      extern char *optarg;
-      extern int optind;
-      int aflg = 0;
-      int bflg = 0;
-      int errflg = 0;
-      char *ofile = NULL;
-
-      while ((c = getopt(argc, argv, "abo:")) != EOF)
-           switch (c) {
-           case 'a':
-                if (bflg)
-                     errflg++;
-                else
-                     aflg++;
-                break;
-           case 'b':
-                if (aflg)
-                     errflg++;
-                else
-                     bflg++;
-                break;
-           case 'o':
-                ofile = optarg;
-                (void)printf("ofile = %s\n", ofile);
-                break;
-           case '?':
-                errflg++;
-           }
-      if (errflg) {
-           (void)fprintf(stderr,
-                "usage: cmd [-a|-b] [-o <filename>] files...\n");
-           exit (2);
-      }
-      for ( ; optind < argc; optind++)
-           (void)printf("%s\n", argv[optind]);
-      return 0;
- }
+main(int argc, char **argv)
+{
+    int c;
+    extern char *optarg;
+    extern int optind;
+    int aflg = 0;
+    int bflg = 0;
+    int errflg = 0;
+    char *ofile = NULL;
+
+    while ((c = getopt(argc, argv, "abo:")) != EOF)
+	switch (c) {
+	case 'a':
+	    if (bflg)
+		errflg++;
+	    else
+		aflg++;
+	    break;
+	case 'b':
+	    if (aflg)
+		errflg++;
+	    else
+		bflg++;
+	    break;
+	case 'o':
+	    ofile = optarg;
+	    (void) printf("ofile = %s\n", ofile);
+	    break;
+	case '?':
+	    errflg++;
+	}
+    if (errflg) {
+	(void) fprintf(stderr, "usage: cmd [-a|-b] [-o <filename>] files...\n");
+	exit(2);
+    }
+    for (; optind < argc; optind++)
+	(void) printf("%s\n", argv[optind]);
+    return 0;
+}
 
 #endif /* TESTGETOPT */
 
-static struct _wsaerrtext {
-	int err;
-	const char *errconst;
-	const char *errdesc;
-} _wsaerrtext[] = {
-WSAEACCES,"WSAEACCES","Permission denied.",
-WSAEADDRINUSE,"WSAEADDRINUSE","Address already in use.",
-WSAEADDRNOTAVAIL,"WSAEADDRNOTAVAIL","Cannot assign requested address.",
-WSAEAFNOSUPPORT,"WSAEAFNOSUPPORT","Address family not supported by protocol family.",
-WSAEALREADY,"WSAEALREADY","Operation already in progress.",
-WSAECONNABORTED,"WSAECONNABORTED","Software caused connection abort.",
-WSAECONNREFUSED,"WSAECONNREFUSED","Connection refused.",
-WSAECONNRESET,"WSAECONNRESET","Connection reset by peer.",
-WSAEDESTADDRREQ,"WSAEDESTADDRREQ","Destination address required.",
-WSAEFAULT,"WSAEFAULT","Bad address.",
-WSAEHOSTDOWN,"WSAEHOSTDOWN","Host is down.",
-WSAEHOSTUNREACH,"WSAEHOSTUNREACH","No route to host.",
-WSAEINPROGRESS,"WSAEINPROGRESS","Operation now in progress.",
-WSAEINTR,"WSAEINTR","Interrupted function call.",
-WSAEINVAL,"WSAEINVAL","Invalid argument.",
-WSAEISCONN,"WSAEISCONN","Socket is already connected.",
-WSAEMFILE,"WSAEMFILE","Too many open files.",
-WSAEMSGSIZE,"WSAEMSGSIZE","Message too long.",
-WSAENETDOWN,"WSAENETDOWN","Network is down.",
-WSAENETRESET,"WSAENETRESET","Network dropped connection on reset.",
-WSAENETUNREACH,"WSAENETUNREACH","Network is unreachable.",
-WSAENOBUFS,"WSAENOBUFS","No buffer space available.",
-WSAENOPROTOOPT,"WSAENOPROTOOPT","Bad protocol option.",
-WSAENOTCONN,"WSAENOTCONN","Socket is not connected.",
-WSAENOTSOCK,"WSAENOTSOCK","Socket operation on nonsocket.",
-WSAEOPNOTSUPP,"WSAEOPNOTSUPP","Operation not supported.",
-WSAEPFNOSUPPORT,"WSAEPFNOSUPPORT","Protocol family not supported.",
-WSAEPROCLIM,"WSAEPROCLIM","Too many processes.",
-WSAEPROTONOSUPPORT,"WSAEPROTONOSUPPORT","Protocol not supported.",
-WSAEPROTOTYPE,"WSAEPROTOTYPE","Protocol wrong type for socket.",
-WSAESHUTDOWN,"WSAESHUTDOWN","Cannot send after socket shutdown.",
-WSAESOCKTNOSUPPORT,"WSAESOCKTNOSUPPORT","Socket type not supported.",
-WSAETIMEDOUT,"WSAETIMEDOUT","Connection timed out.",
-WSAEWOULDBLOCK,"WSAEWOULDBLOCK","Resource temporarily unavailable.",
-WSANOTINITIALISED,"WSANOTINITIALISED","Successful WSAStartup not yet performed.",
-WSASYSNOTREADY,"WSASYSNOTREADY","Network subsystem is unavailable.",
-WSAVERNOTSUPPORTED,"WSAVERNOTSUPPORTED","Winsock.dll version out of range.",
-WSAEDISCON,"WSAEDISCON","Graceful shutdown in progress."
+static struct _wsaerrtext 
+{
+    int err;
+    const char *errconst;
+    const char *errdesc;
+} 
+_wsaerrtext[] = {
+    WSAEACCES, "WSAEACCES", "Permission denied.",
+	WSAEADDRINUSE, "WSAEADDRINUSE", "Address already in use.",
+	WSAEADDRNOTAVAIL, "WSAEADDRNOTAVAIL", "Cannot assign requested address.", 
+	WSAEAFNOSUPPORT, "WSAEAFNOSUPPORT", "Address family not supported by protocol family.", 
+	WSAEALREADY, "WSAEALREADY", "Operation already in progress.", 
+	WSAECONNABORTED, "WSAECONNABORTED", "Software caused connection abort.", 
+	WSAECONNREFUSED, "WSAECONNREFUSED", "Connection refused.", 
+	WSAECONNRESET, "WSAECONNRESET", "Connection reset by peer.", 
+	WSAEDESTADDRREQ, "WSAEDESTADDRREQ", "Destination address required.", 
+	WSAEFAULT, "WSAEFAULT", "Bad address.", 
+	WSAEHOSTDOWN, "WSAEHOSTDOWN", "Host is down.", 
+	WSAEHOSTUNREACH, "WSAEHOSTUNREACH",	"No route to host.", 
+	WSAEINPROGRESS, "WSAEINPROGRESS", "Operation now in progress.", 
+	WSAEINTR, "WSAEINTR", "Interrupted function call.", 
+	WSAEINVAL, "WSAEINVAL",	"Invalid argument.", 
+	WSAEISCONN, "WSAEISCONN", "Socket is already connected.", 
+	WSAEMFILE, "WSAEMFILE",	"Too many open files.", 
+	WSAEMSGSIZE, "WSAEMSGSIZE", "Message too long.",
+	WSAENETDOWN, "WSAENETDOWN", "Network is down.", 
+	WSAENETRESET, "WSAENETRESET", "Network dropped connection on reset.", 
+	WSAENETUNREACH,	"WSAENETUNREACH", "Network is unreachable.", 
+	WSAENOBUFS, "WSAENOBUFS", "No buffer space available.", 
+	WSAENOPROTOOPT, "WSAENOPROTOOPT", "Bad protocol option.", 
+	WSAENOTCONN, "WSAENOTCONN",	"Socket is not connected.", 
+	WSAENOTSOCK, "WSAENOTSOCK",	"Socket operation on nonsocket.", 
+	WSAEOPNOTSUPP, "WSAEOPNOTSUPP",	"Operation not supported.", 
+	WSAEPFNOSUPPORT, "WSAEPFNOSUPPORT",	"Protocol family not supported.", 
+	WSAEPROCLIM, "WSAEPROCLIM",	"Too many processes.", 
+	WSAEPROTONOSUPPORT, "WSAEPROTONOSUPPORT", "Protocol not supported.", 
+	WSAEPROTOTYPE, "WSAEPROTOTYPE",	"Protocol wrong type for socket.", 
+	WSAESHUTDOWN, "WSAESHUTDOWN", "Cannot send after socket shutdown.", 
+	WSAESOCKTNOSUPPORT,	"WSAESOCKTNOSUPPORT", "Socket type not supported.", 
+	WSAETIMEDOUT, "WSAETIMEDOUT", "Connection timed out.", 
+	WSAEWOULDBLOCK,	"WSAEWOULDBLOCK", "Resource temporarily unavailable.",
+	WSANOTINITIALISED, "WSANOTINITIALISED",	"Successful WSAStartup not yet performed.", 
+	WSASYSNOTREADY,	"WSASYSNOTREADY", "Network subsystem is unavailable.",
+	WSAVERNOTSUPPORTED, "WSAVERNOTSUPPORTED", "Winsock.dll version out of range.", 
+	WSAEDISCON, "WSAEDISCON", "Graceful shutdown in progress."
 };
 
 /*
@@ -328,22 +436,34 @@
 wsastrerror(int err)
 {
     static char xwsaerror_buf[BUFSIZ];
-/*	int err = WSAGetLastError();*/
-	int i, errind = -1;
+    int i, errind = -1;
 
-	if ( err == 0 )
-		return "(0) No error.";
-	for ( i = 0; i < sizeof(_wsaerrtext)/sizeof(struct _wsaerrtext); i++ ) {
-		if ( _wsaerrtext[i].err != err )
-			continue;
-		errind = i;
-		break;
-	}
+    if (err == 0)
+	return "(0) No error";
+    for (i = 0; i < sizeof(_wsaerrtext) / sizeof(struct _wsaerrtext); i++) {
+	if (_wsaerrtext[i].err != err)
+	    continue;
+	errind = i;
+	break;
+    }
     if (errind == -1)
-	return ("Unknown");
-	assert(err == _wsaerrtext[errind].err);
-    snprintf(xwsaerror_buf, BUFSIZ, "(%d) %s, %s", err, _wsaerrtext[errind].errconst, _wsaerrtext[errind].errdesc);
+		snprintf(xwsaerror_buf, BUFSIZ, "(%d) Unknown", err);
+	else
+		snprintf(xwsaerror_buf, BUFSIZ, "(%d) %s, %s", err,
+			_wsaerrtext[errind].errconst, _wsaerrtext[errind].errdesc);
     return xwsaerror_buf;
 }
 
+struct passwd *getpwnam(char * unused)
+{
+	static struct passwd pwd = {100};
+	return &pwd;
+}
+
+struct group *getgrnam(char * unused)
+{
+	static struct group grp = {100};
+	return &grp;
+}
+
 #endif
Index: squid/scripts/RunAccel.in
===================================================================
RCS file: /cvsroot/squid-sf//squid/scripts/Attic/RunAccel.in,v
retrieving revision 1.1.1.2.44.1
retrieving revision 1.1.1.2.44.1.2.1
diff -u -r1.1.1.2.44.1 -r1.1.1.2.44.1.2.1
--- squid/scripts/RunAccel.in	6 Jan 2001 12:40:11 -0000	1.1.1.2.44.1
+++ squid/scripts/RunAccel.in	27 Aug 2001 21:48:18 -0000	1.1.1.2.44.1.2.1
@@ -1,6 +1,6 @@
 #!/bin/sh
 #
-#  $Id: RunAccel.in,v 1.1.1.2.44.1 2001/01/06 12:40:11 hno Exp $
+#  $Id: RunAccel.in,v 1.1.1.2.44.1.2.1 2001/08/27 21:48:18 tolsty Exp $
 
 # enable HTTP requests on port 80
 port="-a 80"
Index: squid/scripts/RunCache.in
===================================================================
RCS file: /cvsroot/squid-sf//squid/scripts/RunCache.in,v
retrieving revision 1.1.1.2.44.1
retrieving revision 1.1.1.2.44.1.2.1
diff -u -r1.1.1.2.44.1 -r1.1.1.2.44.1.2.1
--- squid/scripts/RunCache.in	6 Jan 2001 12:40:11 -0000	1.1.1.2.44.1
+++ squid/scripts/RunCache.in	27 Aug 2001 21:48:18 -0000	1.1.1.2.44.1.2.1
@@ -1,6 +1,6 @@
 #!/bin/sh
 #
-#  $Id: RunCache.in,v 1.1.1.2.44.1 2001/01/06 12:40:11 hno Exp $
+#  $Id: RunCache.in,v 1.1.1.2.44.1.2.1 2001/08/27 21:48:18 tolsty Exp $
 
 prefix=@prefix@
 exec_prefix=@exec_prefix@
Index: squid/scripts/check_cache.pl
===================================================================
RCS file: /cvsroot/squid-sf//squid/scripts/check_cache.pl,v
retrieving revision 1.1.1.1.44.1
retrieving revision 1.1.1.1.44.1.2.1
diff -u -r1.1.1.1.44.1 -r1.1.1.1.44.1.2.1
--- squid/scripts/check_cache.pl	6 Jan 2001 12:40:11 -0000	1.1.1.1.44.1
+++ squid/scripts/check_cache.pl	27 Aug 2001 21:48:18 -0000	1.1.1.1.44.1.2.1
@@ -8,7 +8,7 @@
 # Check the Squid-1.1.x cache directory for stale objects - i.e. those
 # which exist on disk but aren't listed in cached's log file.
 
-# $Id: check_cache.pl,v 1.1.1.1.44.1 2001/01/06 12:40:11 hno Exp $
+# $Id: check_cache.pl,v 1.1.1.1.44.1.2.1 2001/08/27 21:48:18 tolsty Exp $
 
 require "getopts.pl";
 &Getopts("c:drt:vh");
Index: squid/scripts/fileno-to-pathname.pl
===================================================================
RCS file: /cvsroot/squid-sf//squid/scripts/fileno-to-pathname.pl,v
retrieving revision 1.1.1.1.44.1
retrieving revision 1.1.1.1.44.1.2.1
diff -u -r1.1.1.1.44.1 -r1.1.1.1.44.1.2.1
--- squid/scripts/fileno-to-pathname.pl	6 Jan 2001 12:40:11 -0000	1.1.1.1.44.1
+++ squid/scripts/fileno-to-pathname.pl	27 Aug 2001 21:48:18 -0000	1.1.1.1.44.1.2.1
@@ -1,6 +1,6 @@
 #!/usr/local/bin/perl
 
-# $Id: fileno-to-pathname.pl,v 1.1.1.1.44.1 2001/01/06 12:40:11 hno Exp $
+# $Id: fileno-to-pathname.pl,v 1.1.1.1.44.1.2.1 2001/08/27 21:48:18 tolsty Exp $
 # Convert hexadecimal cache file numbers (from swap log) into full pathnames.  
 # Duane Wessels 6/30/97
 
Index: squid/scripts/flag_truncs.pl
===================================================================
RCS file: /cvsroot/squid-sf//squid/scripts/flag_truncs.pl,v
retrieving revision 1.1.1.1.44.1
retrieving revision 1.1.1.1.44.1.2.1
diff -u -r1.1.1.1.44.1 -r1.1.1.1.44.1.2.1
--- squid/scripts/flag_truncs.pl	6 Jan 2001 12:40:11 -0000	1.1.1.1.44.1
+++ squid/scripts/flag_truncs.pl	27 Aug 2001 21:48:18 -0000	1.1.1.1.44.1.2.1
@@ -6,7 +6,7 @@
 # - i.e. those for which there is a "Content-length:" HTTP header,
 #   and this does not match the size of the cached object
 
-# $Id: flag_truncs.pl,v 1.1.1.1.44.1 2001/01/06 12:40:11 hno Exp $
+# $Id: flag_truncs.pl,v 1.1.1.1.44.1.2.1 2001/08/27 21:48:18 tolsty Exp $
 
 require "getopts.pl";
 require "stat.pl";
Index: squid/scripts/upgrade-1.0-store.pl
===================================================================
RCS file: /cvsroot/squid-sf//squid/scripts/upgrade-1.0-store.pl,v
retrieving revision 1.1.1.1.44.1
retrieving revision 1.1.1.1.44.1.2.1
diff -u -r1.1.1.1.44.1 -r1.1.1.1.44.1.2.1
--- squid/scripts/upgrade-1.0-store.pl	6 Jan 2001 12:40:11 -0000	1.1.1.1.44.1
+++ squid/scripts/upgrade-1.0-store.pl	27 Aug 2001 21:48:18 -0000	1.1.1.1.44.1.2.1
@@ -1,6 +1,6 @@
 #!/usr/local/bin/perl
 
-# $Id: upgrade-1.0-store.pl,v 1.1.1.1.44.1 2001/01/06 12:40:11 hno Exp $
+# $Id: upgrade-1.0-store.pl,v 1.1.1.1.44.1.2.1 2001/08/27 21:48:18 tolsty Exp $
 
 select(STDERR); $|=1;
 select(STDOUT); $|=1;
Index: squid/snmplib/asn1.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/snmplib/asn1.c,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.1.136.1
diff -u -r1.1.1.1 -r1.1.1.1.136.1
--- squid/snmplib/asn1.c	26 Jan 2000 03:21:47 -0000	1.1.1.1
+++ squid/snmplib/asn1.c	27 Aug 2001 21:48:18 -0000	1.1.1.1.136.1
@@ -87,7 +87,7 @@
 u_char *
 asn_build_header(u_char * data,	/* IN - ptr to start of object */
     int *datalength,		/* IN/OUT - # of valid bytes */
-					     /*          left in buffer */
+    /*          left in buffer */
     u_char type,		/* IN - ASN type of object */
     int length)
 {				/* IN - length of object */
@@ -539,8 +539,7 @@
  *  Returns NULL on any error.
  */
 u_char *
-asn_build_sequence(u_char * data, int *datalength,
-    u_char type, int length)
+asn_build_sequence(u_char * data, int *datalength, u_char type, int length)
   /*    u_char *data;       IN - pointer to start of object */
   /*    int    *datalength; IN/OUT - # of valid bytes left in buffer */
   /*    u_char  type;       IN - ASN type of object */
@@ -601,8 +600,7 @@
 
 
 u_char *
-asn_build_length(u_char * data, int *datalength,
-    int length, int truth)
+asn_build_length(u_char * data, int *datalength, int length, int truth)
   /*   u_char *data;       IN - pointer to start of object */
   /*   int    *datalength; IN/OUT - # of valid bytes left in buf */
   /*   int     length;     IN - length of object */
@@ -794,7 +792,7 @@
 	    /* testmask *MUST* !!!! be of an unsigned type */
 	    for (testmask = 0x7F, testbits = 0; testmask != 0;
 		testmask <<= 7, testbits += 7) {
-		if (subid & testmask) {		/* if any bits set */
+		if (subid & testmask) {	/* if any bits set */
 		    mask = testmask;
 		    bits = testbits;
 		}
Index: squid/snmplib/coexistance.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/snmplib/coexistance.c,v
retrieving revision 1.1.1.1
retrieving revision 1.1.1.1.76.1
diff -u -r1.1.1.1 -r1.1.1.1.76.1
--- squid/snmplib/coexistance.c	26 Jan 2000 03:21:47 -0000	1.1.1.1
+++ squid/snmplib/coexistance.c	27 Aug 2001 21:48:18 -0000	1.1.1.1.76.1
@@ -100,7 +100,7 @@
  * valid V1 responses.  (I think. XXXXX)
  *
  */
-int 
+int
 snmp_coexist_V2toV1(struct snmp_pdu *PDU)
 {
     /* Per 3.1.1:
@@ -121,7 +121,8 @@
 	break;
 
     default:
-	snmplib_debug(2, "Unable to translate PDU %d to SNMPv1!\n", PDU->command);
+	snmplib_debug(2, "Unable to translate PDU %d to SNMPv1!\n",
+	    PDU->command);
 	snmp_set_api_error(SNMPERR_PDU_TRANSLATION);
 	return (0);
     }
